Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3359)
@@ -442,9 +442,9 @@
                CALL histdef( nid_T, "berg_melt"           , "Melt rate of icebergs"                    , "kg/m2/s", &
                   &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-               CALL histdef( nid_T, "berg_melt_buoy"      , "Buoyancy component of iceberg melt rate"  , "kg/m2/s", &
+               CALL histdef( nid_T, "berg_buoy_melt"      , "Buoyancy component of iceberg melt rate"  , "kg/m2/s", &
                   &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-               CALL histdef( nid_T, "berg_melt_eros"      , "Erosion component of iceberg melt rate"   , "kg/m2/s", &
+               CALL histdef( nid_T, "berg_eros_melt"      , "Erosion component of iceberg melt rate"   , "kg/m2/s", &
                   &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-               CALL histdef( nid_T, "berg_melt_conv"      , "Convective component of iceberg melt rate", "kg/m2/s", &
+               CALL histdef( nid_T, "berg_conv_melt"      , "Convective component of iceberg melt rate", "kg/m2/s", &
                   &          jpi, jpj, nh_T, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
                CALL histdef( nid_T, "berg_virtual_area"   , "Virtual coverage by icebergs"             , "m2"     , &
@@ -628,11 +628,11 @@
          IF( ln_bergdia ) THEN
             CALL histwrite( nid_T, "berg_melt"           , it, berg_melt        , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "berg_melt_buoy"      , it, melt_buoy        , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "berg_melt_eros"      , it, melt_eros        , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "berg_melt_conv"      , it, melt_conv        , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "berg_buoy_melt"      , it, buoy_melt        , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "berg_eros_melt"      , it, eros_melt        , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "berg_conv_melt"      , it, conv_melt        , ndim_hT, ndex_hT   )  
             CALL histwrite( nid_T, "berg_virtual_area"   , it, virtual_area     , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "bits_src"           , it, bits_src        , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "bits_melt"          , it, bits_melt       , ndim_hT, ndex_hT   )  
-            CALL histwrite( nid_T, "bits_mass"          , it, bits_mass       , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "bits_src"            , it, bits_src         , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "bits_melt"           , it, bits_melt        , ndim_hT, ndex_hT   )  
+            CALL histwrite( nid_T, "bits_mass"           , it, bits_mass        , ndim_hT, ndex_hT   )  
             CALL histwrite( nid_T, "berg_mass"           , it, berg_mass        , ndim_hT, ndex_hT   )  
             !
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icb_oce.F90	(revision 3359)
@@ -88,6 +88,6 @@
    INTEGER                         ::   current_year
    REAL(wp)                        ::   current_yearday            ! 1.00-365.99
-   REAL(wp), DIMENSION(:), POINTER ::   initial_width, initial_length
-   LOGICAL                         ::   restarted_bergs=.false.          ! Indicate whether we read state from a restart or not
+   REAL(wp), DIMENSION(:), POINTER ::   first_width, first_length
+   LOGICAL                         ::   l_restarted_bergs=.FALSE.          ! Indicate whether we read state from a restart or not
    !                                                           ! arbitrary numbers for diawri entry
    REAL(wp), DIMENSION(nclasses), PUBLIC ::   class_num=(/ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 /)
@@ -107,15 +107,15 @@
 
    !!gm almost all those PARAM ARE defined in NEMO
-   REAL(wp), PUBLIC, PARAMETER :: rho_ice      = 916.7_wp   ! Density of fresh ice @ 0oC (kg/m^3)
-   REAL(wp), PUBLIC, PARAMETER :: rho_water    = 999.8_wp   ! Density of fresh water @ 0oC (kg/m^3)
-   REAL(wp), PUBLIC, PARAMETER :: rho_air      = 1.1_wp     ! Density of air @ 0oC (kg/m^3) ???
-   REAL(wp), PUBLIC, PARAMETER :: rho_seawater = 1025._wp   ! Approx. density of surface sea water @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_ice      = 916.7_wp   ! Density of fresh ice @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_water    = 999.8_wp   ! Density of fresh water @ 0oC (kg/m^3)
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_air      = 1.1_wp     ! Density of air @ 0oC (kg/m^3) ???
+   REAL(wp), PUBLIC, PARAMETER :: pp_rho_seawater = 1025._wp   ! Approx. density of surface sea water @ 0oC (kg/m^3)
    !!gm end
-   REAL(wp), PUBLIC, PARAMETER :: Cd_av = 1.3_wp      ! (Vertical) Drag coefficient between bergs and atmos (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_ah = 0.0055_wp   ! (Horizontal) Drag coefficient between bergs and atmos (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_wv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and ocean (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_wh = 0.0012_wp   ! (Horizontal) Drag coefficient between bergs and ocean (?)
-   REAL(wp), PUBLIC, PARAMETER :: Cd_iv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and sea-ice (?)
-   !TOM> no horizontal drag for sea ice! real, PARAMETER :: Cd_ih=0.0012 ! (Horizontal) Drag coefficient between bergs and sea-ice (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_av = 1.3_wp      ! (Vertical) Drag coefficient between bergs and atmos (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_ah = 0.0055_wp   ! (Horizontal) Drag coefficient between bergs and atmos (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_wv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and ocean (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_wh = 0.0012_wp   ! (Horizontal) Drag coefficient between bergs and ocean (?)
+   REAL(wp), PUBLIC, PARAMETER :: pp_Cd_iv = 0.9_wp      ! (Vertical) Drag coefficient between bergs and sea-ice (?)
+   !TOM> no horizontal drag for sea ice! real, PARAMETER :: pp_Cd_ih=0.0012 ! (Horizontal) Drag coefficient between bergs and sea-ice (?)
 
    !                                           !** namberg namelist parameters (and defaults) **
@@ -147,14 +147,14 @@
 
    ! Single instance of an icebergs type initialised in icebergs_init and updated in icebergs_run
-   REAL(wp), ALLOCATABLE, PUBLIC, SAVE, DIMENSION(:,:)     ::   p_calving, p_calving_hflx
+   REAL(wp), ALLOCATABLE, PUBLIC, SAVE, DIMENSION(:,:)     ::   src_calving, src_calving_hflx
    INTEGER              , PUBLIC, SAVE                     ::   numicb 
-   INTEGER              , PUBLIC, SAVE, DIMENSION(nkounts) ::   kount_bergs
-   INTEGER              , PUBLIC, SAVE                     ::   icbdi, icbei, icbdj, icbej
-   REAL(wp)             , PUBLIC, SAVE                     ::   icb_left, icb_right
-   INTEGER              , PUBLIC, SAVE                     ::   icbpack
-   INTEGER              , PUBLIC, SAVE                     ::   ktberg, knberg
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbfldpts
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbflddest
-   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   icbfldproc
+   INTEGER              , PUBLIC, SAVE, DIMENSION(nkounts) ::   num_bergs
+   INTEGER              , PUBLIC, SAVE                     ::   nicbdi, nicbei, nicbdj, nicbej
+   REAL(wp)             , PUBLIC, SAVE                     ::   ricb_left, ricb_right
+   INTEGER              , PUBLIC, SAVE                     ::   nicbpack
+   INTEGER              , PUBLIC, SAVE                     ::   nktberg, nknberg
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbfldpts
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbflddest
+   INTEGER, ALLOCATABLE , PUBLIC, SAVE, DIMENSION(:)       ::   nicbfldproc
 
    TYPE(FLD), ALLOCATABLE, PUBLIC     , DIMENSION(:)       ::   sf_icb       ! structure: file information, fields read
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbclv.F90	(revision 3359)
@@ -14,5 +14,4 @@
    !!   accumulate_calving      :
    !!   icb_gen       : generate test icebergs
-   !!   icb_nam       : read iceberg namelist
    !!----------------------------------------------------------------------
    USE par_oce        ! NEMO parameters
@@ -29,6 +28,6 @@
    PRIVATE
 
-   PUBLIC   accumulate_calving  ! routine called in xxx.F90 module
-   PUBLIC   calve_icebergs      ! routine called in xxx.F90 module
+   PUBLIC   accumulate_calving  ! routine called in icbrun.F90 module
+   PUBLIC   calve_icebergs      ! routine called in icbrun.F90 module
 
 CONTAINS
@@ -43,8 +42,10 @@
       !!----------------------------------------------------------------------
       !
-      INTEGER                         :: kt
-      REAL(wp)                        :: calving_used, rdist, ufact
-      INTEGER                         :: jn, ji, jj, nmax
-      LOGICAL, SAVE                   :: first_call = .TRUE.
+      INTEGER, INTENT(in)             :: kt
+      !
+      REAL(wp)                        :: zcalving_used, zdist, zfact
+      INTEGER                         :: jn, ji, jj                    ! loop counters
+      INTEGER                         :: imx                           ! temporary integer for max berg class
+      LOGICAL, SAVE                   :: ll_first_call = .TRUE.
       !!----------------------------------------------------------------------
       !
@@ -52,12 +53,12 @@
       ! Use interior mask: so no bergs in overlap areas and convert from km^3/year to kg/s
       ! this assumes that input is given as equivalent water flux so that pure water density is appropriate
-      ufact = ( (1000._wp)**3 / ( NINT(rday) * nyear_len(1) ) ) * 1000._wp
-      berg_grid%calving(:,:) = p_calving(:,:) * tmask_i(:,:) * ufact
+      zfact = ( (1000._wp)**3 / ( NINT(rday) * nyear_len(1) ) ) * 1000._wp
+      berg_grid%calving(:,:) = src_calving(:,:) * tmask_i(:,:) * zfact
 
       ! Heat in units of W/m2, and mask (just in case)
-      berg_grid%calving_hflx(:,:) = p_calving_hflx(:,:) * tmask_i(:,:)
+      berg_grid%calving_hflx(:,:) = src_calving_hflx(:,:) * tmask_i(:,:)
 
-      IF( first_call .AND. .NOT.restarted_bergs) THEN      ! This is a hack to simplify initialization
-         first_call = .FALSE.
+      IF( ll_first_call .AND. .NOT. l_restarted_bergs) THEN      ! This is a hack to simplify initialization
+         ll_first_call = .FALSE.
          !do jn=1, nclasses
          !  where (berg_grid%calving==0.) berg_grid%stored_ice(:,:,jn)=0.
@@ -77,9 +78,9 @@
       DO jj = 1,jpj
          DO ji = 1,jpi
-            nmax = berg_grid%maxclass(ji,jj)
-            rdist = SUM( rn_distribution(1:nclasses) ) / SUM( rn_distribution(1:nmax) )
-            DO jn = 1, nmax
+            imx = berg_grid%maxclass(ji,jj)
+            zdist = SUM( rn_distribution(1:nclasses) ) / SUM( rn_distribution(1:imx) )
+            DO jn = 1, imx
                berg_grid%stored_ice(ji,jj,jn) = berg_grid%stored_ice(ji,jj,jn) + &
-                                          berg_dt * berg_grid%calving(ji,jj) * rn_distribution(jn) * rdist
+                                          berg_dt * berg_grid%calving(ji,jj) * rn_distribution(jn) * zdist
             END DO
          END DO
@@ -87,12 +88,10 @@
 
       ! before changing the calving, save the amount we're about to use and do budget
-      calving_used = SUM( berg_grid%calving(:,:) )
+      zcalving_used = SUM( berg_grid%calving(:,:) )
       berg_grid%tmp(:,:) = berg_dt * berg_grid%calving_hflx(:,:) * e1e2t(:,:) * tmask_i(:,:)
       berg_grid%stored_heat (:,:) = berg_grid%stored_heat (:,:) + berg_grid%tmp(:,:)
-      CALL incoming_budget( kt,  calving_used, berg_grid%tmp )
+      CALL incoming_budget( kt,  zcalving_used, berg_grid%tmp )
       !
    END SUBROUTINE accumulate_calving
-
-! ##############################################################################
 
    SUBROUTINE calve_icebergs()
@@ -114,7 +113,6 @@
       TYPE(iceberg)                   ::   newberg
       TYPE(point)                     ::   newpt
-      LOGICAL                         ::   lret
-      INTEGER                         ::   ji, jj, jn   ! dummy loop indices
-      REAL(wp)                        ::   xi, yj, ddt, calved_to_berg, heat_to_berg
+      INTEGER                         ::   ji, jj, jn                             ! dummy loop indices
+      REAL(wp)                        ::   zddt, zcalved_to_berg, zheat_to_berg
       !!----------------------------------------------------------------------
 
@@ -122,8 +120,8 @@
 
       DO jn = 1, nclasses
-         DO jj = icbdj, icbej
-            DO ji = icbdi, icbei
+         DO jj = nicbdj, nicbej
+            DO ji = nicbdi, nicbei
                !
-               ddt  = 0._wp
+               zddt  = 0._wp
                icnt = 0
                !
@@ -140,29 +138,29 @@
                   newpt%mass         = rn_initial_mass     (jn)
                   newpt%thickness    = rn_initial_thickness(jn)
-                  newpt%width        = initial_width    (jn)
-                  newpt%length       = initial_length   (jn)
+                  newpt%width        = first_width    (jn)
+                  newpt%length       = first_length   (jn)
                   newberg%mass_scaling = rn_mass_scaling     (jn)
                   newpt%mass_of_bits = 0._wp                          ! no bergy
                   !
                   newpt%year   = current_year
-                  newpt%day    = current_yearday + ddt / rday
+                  newpt%day    = current_yearday + zddt / rday
                   newpt%heat_density = berg_grid%stored_heat(ji,jj) / berg_grid%stored_ice(ji,jj,jn)   ! This is in J/kg
                   !
                   CALL increment_kounter()
-                  newberg%number(:) = kount_bergs(:)
+                  newberg%number(:) = num_bergs(:)
                   !
                   CALL add_new_berg_to_list( newberg, newpt )
                   !
-                  calved_to_berg = rn_initial_mass(jn) * rn_mass_scaling(jn)           ! Units of kg
+                  zcalved_to_berg = rn_initial_mass(jn) * rn_mass_scaling(jn)           ! Units of kg
                   !                                ! Heat content
-                  heat_to_berg           = calved_to_berg * newpt%heat_density             ! Units of J
-                  berg_grid%stored_heat(ji,jj) = berg_grid%stored_heat(ji,jj) - heat_to_berg
+                  zheat_to_berg           = zcalved_to_berg * newpt%heat_density             ! Units of J
+                  berg_grid%stored_heat(ji,jj) = berg_grid%stored_heat(ji,jj) - zheat_to_berg
                   !                                ! Stored mass
-                  berg_grid%stored_ice(ji,jj,jn)   = berg_grid%stored_ice(ji,jj,jn) - calved_to_berg
+                  berg_grid%stored_ice(ji,jj,jn)   = berg_grid%stored_ice(ji,jj,jn) - zcalved_to_berg
                   !
-                  ddt  = ddt + berg_dt * 2._wp / 17._wp    ! Minor offset to start day    !!gm why???
+                  zddt  = zddt + berg_dt * 2._wp / 17._wp    ! Minor offset to start day    !!gm why???
                   icnt = icnt + 1
                   !
-                  CALL calving_budget(ji, jj, jn,  calved_to_berg, heat_to_berg )
+                  CALL calving_budget(ji, jj, jn,  zcalved_to_berg, zheat_to_berg )
                END DO
                icntmax = MAX( icntmax, icnt )
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 3359)
@@ -30,32 +30,32 @@
 
    REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: berg_melt=>NULL()    ! Melting+erosion rate of icebergs (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: melt_buoy=>NULL()    ! Buoyancy component of melting rate (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: melt_eros=>NULL()    ! Erosion component of melting rate (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: melt_conv=>NULL()    ! Convective component of melting rate (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_src=>NULL()    ! Mass flux from berg erosion into bergy bits (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_melt=>NULL()   ! Melting rate of bergy bits (kg/s/m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_mass=>NULL()   ! Mass distribution of bergy bits (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: buoy_melt=>NULL()    ! Buoyancy component of melting rate (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: eros_melt=>NULL()    ! Erosion component of melting rate (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: conv_melt=>NULL()    ! Convective component of melting rate (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_src=>NULL()     ! Mass flux from berg erosion into bergy bits (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_melt=>NULL()    ! Melting rate of bergy bits (kg/s/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: bits_mass=>NULL()    ! Mass distribution of bergy bits (kg/s/m^2)
    REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: virtual_area=>NULL() ! Virtual surface coverage by icebergs (m^2)
-   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: berg_mass=>NULL()         ! Mass distribution (kg/m^2)
+   REAL(wp), DIMENSION(:,:)  , POINTER, PUBLIC  :: berg_mass=>NULL()    ! Mass distribution (kg/m^2)
    REAL(wp), DIMENSION(:,:,:), POINTER, PUBLIC  :: real_calving=>NULL() ! Calving rate into iceberg class at calving locations (kg/s)
    REAL(wp), DIMENSION(:,:)  , POINTER, PRIVATE :: tmpc=>NULL()         ! Temporary work space
-   REAL(wp), DIMENSION(:)    , POINTER, PRIVATE :: zsumbuf=>NULL()         ! Temporary work space
-   INTEGER , DIMENSION(:)    , POINTER, PRIVATE :: isumbuf=>NULL()         ! Temporary work space
-
-   REAL(wp)                           , PRIVATE ::  net_berg_melt
-   REAL(wp)                           , PRIVATE ::  net_bits_src
-   REAL(wp)                           , PRIVATE ::  net_bits_melt
+   REAL(wp), DIMENSION(:)    , POINTER, PRIVATE :: rsumbuf=>NULL()      ! Temporary work space to reduce mpp exchanges
+   INTEGER , DIMENSION(:)    , POINTER, PRIVATE :: nsumbuf=>NULL()      ! Temporary work space to reduce mpp exchanges
+
+   REAL(wp)                           , PRIVATE ::  berg_melt_net
+   REAL(wp)                           , PRIVATE ::  bits_src_net
+   REAL(wp)                           , PRIVATE ::  bits_melt_net
    REAL(wp)                           , PRIVATE ::  bits_mass_start, bits_mass_end
    REAL(wp)                           , PRIVATE ::  floating_heat_start, floating_heat_end
    REAL(wp)                           , PRIVATE ::  floating_mass_start, floating_mass_end
-   REAL(wp)                           , PRIVATE ::  icebergs_mass_start, icebergs_mass_end
+   REAL(wp)                           , PRIVATE ::  bergs_mass_start, bergs_mass_end
    REAL(wp)                           , PRIVATE ::  stored_start, stored_heat_start
    REAL(wp)                           , PRIVATE ::  stored_end  , stored_heat_end
-   REAL(wp)                           , PRIVATE ::  net_incoming_calving, net_outgoing_calving
-   REAL(wp)                           , PRIVATE ::  net_incoming_calving_heat, net_outgoing_calving_heat
-   REAL(wp)                           , PRIVATE ::  net_incoming_calving_heat_used
-   REAL(wp)                           , PRIVATE ::  net_calving_received, net_calving_returned, net_calving_used
-   REAL(wp)                           , PRIVATE ::  net_heat_to_bergs, net_heat_to_ocean, net_melt
-   REAL(wp)                           , PRIVATE ::  net_calving_to_bergs
+   REAL(wp)                           , PRIVATE ::  calving_src_net, calving_out_net
+   REAL(wp)                           , PRIVATE ::  calving_src_heat_net, calving_out_heat_net
+   REAL(wp)                           , PRIVATE ::  calving_src_heat_used_net
+   REAL(wp)                           , PRIVATE ::  calving_rcv_net, calving_ret_net, calving_used_net
+   REAL(wp)                           , PRIVATE ::  heat_to_bergs_net, heat_to_ocean_net, melt_net
+   REAL(wp)                           , PRIVATE ::  calving_to_bergs_net
 
    INTEGER                            , PRIVATE ::  nbergs_start, nbergs_end, nbergs_calved
@@ -64,14 +64,14 @@
    INTEGER , DIMENSION(nclasses)      , PRIVATE ::  nbergs_calved_by_class
 
-   PUBLIC   icb_budget_end  ! routine called in xxx.F90 module
-   PUBLIC   icb_budget_init ! routine called in xxx.F90 module
-   PUBLIC   icb_budget      ! routine called in xxx.F90 module
-   PUBLIC   icb_budget_step ! routine called in xxx.F90 module
-   PUBLIC   icb_budget_put  ! routine called in xxx.F90 module
-   PUBLIC   melt_budget     ! routine called in xxx.F90 module
-   PUBLIC   size_budget     ! routine called in xxx.F90 module
-   PUBLIC   speed_budget     ! routine called in xxx.F90 module
-   PUBLIC   calving_budget  ! routine called in xxx.F90 module
-   PUBLIC   incoming_budget   ! routine called in xxx.F90 module
+   PUBLIC   icb_budget_end  ! routine called in icbrun.F90 module
+   PUBLIC   icb_budget_init ! routine called in icbini.F90 module
+   PUBLIC   icb_budget      ! routine called in icbrun.F90 module
+   PUBLIC   icb_budget_step ! routine called in icbrun.F90 module
+   PUBLIC   icb_budget_put  ! routine called in icbrun.F90 module
+   PUBLIC   melt_budget     ! routine called in icbthm.F90 module
+   PUBLIC   size_budget     ! routine called in icbthm.F90 module
+   PUBLIC   speed_budget    ! routine called in icbdyn.F90 module
+   PUBLIC   calving_budget  ! routine called in icbclv.F90 module
+   PUBLIC   incoming_budget ! routine called in icbclv.F90 module
 
 CONTAINS
@@ -83,7 +83,7 @@
       IF( .NOT. ln_bergdia ) RETURN
       DEALLOCATE( berg_melt )
-      DEALLOCATE( melt_buoy )
-      DEALLOCATE( melt_eros )
-      DEALLOCATE( melt_conv )
+      DEALLOCATE( buoy_melt )
+      DEALLOCATE( eros_melt )
+      DEALLOCATE( conv_melt )
       DEALLOCATE( bits_src )
       DEALLOCATE( bits_melt )
@@ -94,6 +94,6 @@
       DEALLOCATE( tmpc )
       IF( lk_mpp ) THEN
-         DEALLOCATE( zsumbuf )
-         DEALLOCATE( isumbuf )
+         DEALLOCATE( rsumbuf )
+         DEALLOCATE( nsumbuf )
       ENDIF
 
@@ -106,10 +106,10 @@
       IF( .NOT. ln_bergdia ) RETURN
       ALLOCATE( berg_melt    (jpi,jpj)   )           ;   berg_melt    (:,:) = 0._wp
-      ALLOCATE( melt_buoy    (jpi,jpj)   )           ;   melt_buoy    (:,:) = 0._wp
-      ALLOCATE( melt_eros    (jpi,jpj)   )           ;   melt_eros    (:,:) = 0._wp
-      ALLOCATE( melt_conv    (jpi,jpj)   )           ;   melt_conv    (:,:) = 0._wp
-      ALLOCATE( bits_src    (jpi,jpj)   )           ;   bits_src    (:,:) = 0._wp
-      ALLOCATE( bits_melt   (jpi,jpj)   )           ;   bits_melt   (:,:) = 0._wp
-      ALLOCATE( bits_mass   (jpi,jpj)   )           ;   bits_mass   (:,:) = 0._wp
+      ALLOCATE( buoy_melt    (jpi,jpj)   )           ;   buoy_melt    (:,:) = 0._wp
+      ALLOCATE( eros_melt    (jpi,jpj)   )           ;   eros_melt    (:,:) = 0._wp
+      ALLOCATE( conv_melt    (jpi,jpj)   )           ;   conv_melt    (:,:) = 0._wp
+      ALLOCATE( bits_src     (jpi,jpj)   )           ;   bits_src    (:,:) = 0._wp
+      ALLOCATE( bits_melt    (jpi,jpj)   )           ;   bits_melt   (:,:) = 0._wp
+      ALLOCATE( bits_mass    (jpi,jpj)   )           ;   bits_mass   (:,:) = 0._wp
       ALLOCATE( virtual_area (jpi,jpj)   )           ;   virtual_area (:,:) = 0._wp
       ALLOCATE( berg_mass    (jpi,jpj)   )           ;   berg_mass    (:,:) = 0._wp
@@ -117,53 +117,53 @@
       ALLOCATE( tmpc(jpi,jpj) )                      ;   tmpc(:,:)=0.
 
-      nbergs_start                   = 0
-      nbergs_end                     = 0
-      stored_end                     = 0._wp
-      nbergs_start                   = 0._wp
-      stored_start                   = 0._wp
-      nbergs_melted                  = 0
-      nbergs_calved                  = 0
-      nbergs_calved_by_class(:)      = 0
-      nspeeding_tickets              = 0
-      stored_heat_end                = 0._wp
-      floating_heat_end              = 0._wp
-      floating_mass_end              = 0._wp
-      icebergs_mass_end              = 0._wp
-      bits_mass_end                 = 0._wp
-      stored_heat_start              = 0._wp
-      floating_heat_start            = 0._wp
-      floating_mass_start            = 0._wp
-      icebergs_mass_start            = 0._wp
-      bits_mass_start               = 0._wp
-      bits_mass_end                 = 0._wp
-      net_calving_used               = 0._wp
-      net_calving_to_bergs           = 0._wp
-      net_heat_to_bergs              = 0._wp
-      net_heat_to_ocean              = 0._wp
-      net_calving_received           = 0._wp
-      net_calving_returned           = 0._wp
-      net_incoming_calving           = 0._wp
-      net_outgoing_calving           = 0._wp
-      net_incoming_calving_heat      = 0._wp
-      net_incoming_calving_heat_used = 0._wp
-      net_outgoing_calving_heat      = 0._wp
-      net_melt                       = 0._wp
-      net_berg_melt                  = 0._wp
-      net_bits_melt                 = 0._wp
-      net_bits_src                  = 0._wp
-
-      floating_mass_start            = sum_mass( first_berg )
-      icebergs_mass_start            = sum_mass( first_berg, justbergs=.true. )
-      bits_mass_start               = sum_mass( first_berg, justbits=.true. )
+      nbergs_start              = 0
+      nbergs_end                = 0
+      stored_end                = 0._wp
+      nbergs_start              = 0._wp
+      stored_start              = 0._wp
+      nbergs_melted             = 0
+      nbergs_calved             = 0
+      nbergs_calved_by_class(:) = 0
+      nspeeding_tickets         = 0
+      stored_heat_end           = 0._wp
+      floating_heat_end         = 0._wp
+      floating_mass_end         = 0._wp
+      bergs_mass_end            = 0._wp
+      bits_mass_end             = 0._wp
+      stored_heat_start         = 0._wp
+      floating_heat_start       = 0._wp
+      floating_mass_start       = 0._wp
+      bergs_mass_start          = 0._wp
+      bits_mass_start           = 0._wp
+      bits_mass_end             = 0._wp
+      calving_used_net          = 0._wp
+      calving_to_bergs_net      = 0._wp
+      heat_to_bergs_net         = 0._wp
+      heat_to_ocean_net         = 0._wp
+      calving_rcv_net           = 0._wp
+      calving_ret_net           = 0._wp
+      calving_src_net           = 0._wp
+      calving_out_net           = 0._wp
+      calving_src_heat_net      = 0._wp
+      calving_src_heat_used_net = 0._wp
+      calving_out_heat_net      = 0._wp
+      melt_net                  = 0._wp
+      berg_melt_net             = 0._wp
+      bits_melt_net             = 0._wp
+      bits_src_net              = 0._wp
+
+      floating_mass_start       = sum_mass( first_berg )
+      bergs_mass_start          = sum_mass( first_berg, justbergs=.true. )
+      bits_mass_start           = sum_mass( first_berg, justbits=.true. )
       IF( lk_mpp ) THEN
-         ALLOCATE( zsumbuf(23) )          ; zsumbuf(:) = 0._wp
-         ALLOCATE( isumbuf(4+nclasses) )  ; isumbuf(:) = 0
-         zsumbuf(1) = floating_mass_start
-         zsumbuf(2) = icebergs_mass_start
-         zsumbuf(3) = bits_mass_start
-         CALL mpp_sum( zsumbuf(1:3), 3 )
-         floating_mass_start = zsumbuf(1)
-         icebergs_mass_start = zsumbuf(2)
-         bits_mass_start = zsumbuf(3)
+         ALLOCATE( rsumbuf(23) )          ; rsumbuf(:) = 0._wp
+         ALLOCATE( nsumbuf(4+nclasses) )  ; nsumbuf(:) = 0
+         rsumbuf(1) = floating_mass_start
+         rsumbuf(2) = bergs_mass_start
+         rsumbuf(3) = bits_mass_start
+         CALL mpp_sum( rsumbuf(1:3), 3 )
+         floating_mass_start = rsumbuf(1)
+         bergs_mass_start = rsumbuf(2)
+         bits_mass_start = rsumbuf(3)
       ENDIF
 
